import structs.FrameData;
import structs.GameData;
import structs.Key;
import structs.MotionData;
import gameInterface.AIInterface;
import commandcenter.CommandCenter;;


/****************************************************
 * This class is FightGameAI AI for Fighting ICE.	*
 * @author Mr.Jang, Team Sejong University.			*
 ****************************************************/
public class SejongAI implements AIInterface
{	
	boolean playerNumber;
	GameData gameData;
	FrameData frameData;
	Key inputKey;
	Key enemyKey;
	CommandCenter cmd;
	MotionData motionData;

	@Override
	public int initialize(GameData gameData, boolean playerNumber) 
	{		
		// get character number. if playerNumber is true, character number is 1.
		this.playerNumber = playerNumber;
		this.gameData = gameData;
		this.inputKey = new Key();
		this.inputKey.empty();
		this.frameData = new FrameData();
		this.cmd = new CommandCenter();
		return 0;
	}

	@Override
	public void getInformation(FrameData frameData)
	{
		// get and save frameData 
		this.frameData = frameData;
	}
	
	@Override
	public void processing() 
	{
		cmd.setFrameData(this.frameData, playerNumber);
		if(!frameData.emptyFlag&&frameData.getRemainingTime()>0)
		{
			if(cmd.getskillFlag())
			{
				inputKey = cmd.getSkillKey();
			}
			else
			{
				inputKey.empty();
			    cmd.skillCancel();
			    if(playerNumber)
			    {
					enemyKey = frameData.getKeyData().getPlayerTwo();
			    }
			    else
			    {
					enemyKey = frameData.getKeyData().getPlayerOne();
			    }
				
				if(cmd.getDistanceX() > 195)
				{
					if(cmd.getDistanceY() > 0)
					{
						if(cmd.getMyEnergy() < 300)
						{
							cmd.commandCall("STAND_D_DF_FA");
						}
						else if(cmd.getMyEnergy() >= 300)
						{
							cmd.commandCall("STAND_D_DF_FC");
						}
					}
					else if(cmd.getDistanceY() == 0)
					{
						cmd.commandCall("STAND_D_DB_BB");
					}				
				}
				else if(cmd.getDistanceX() <= 195)
				{
					if(cmd.getDistanceY() > 0)
					{
						//cmd.commandCall("STAND_F_D_DFA");
						cmd.commandCall("AIR_UB");
						//cmd.commandCall("STAND_D_DF_FC");
					}
					else if(cmd.getDistanceY() == 0)
					{
						if(cmd.getDistanceX() == 195)
						{
							if( cmd.getMyEnergy() > 300 )
							{
								cmd.commandCall("STAND_D_DF_FC");
							}
							else if( cmd.getMyEnergy() < 300)
							{
								cmd.commandCall("STAND_F_D_DFA");
							}
						}
						if(cmd.getDistanceX() < 50)
						{
							cmd.commandCall("STAND_F_D_DFA");
							//cmd.commandCall("STAND_D_DF_FC");
						}
						if(cmd.getDistanceX() < 40)
						{
							cmd.commandCall("THROW_HIT");
						}
						if( cmd.getEnemyY() - cmd.getMyY() < 0)
						{
							cmd.commandCall("STAND_D_DB_BB");
						}
						if((enemyKey.U && enemyKey.L) || (enemyKey.U && enemyKey.R))
						{
							cmd.commandCall("AIR_UB");
						}
						cmd.commandCall("STAND_D_DB_BB");
					}
					else if(cmd.getDistanceX() < 100)
					{
						
					}
					else if(cmd.getDistanceY() < 0)
					{
						cmd.commandCall("STAND_D_DB_BB");
					}
				}
			    
			}
		}
	}
	

	@Override
	public Key input()
	{
		frameData.empty();
		// return key
		return inputKey;
	}

	@Override
	public void close() {
		// TODO Auto-generated method stub
		
	}
}
